/** ised - generating integer and floating point sequences
    Copyright (C) 2009-2011  Simon Copar

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
**/

#ifndef H_TOKENER
#define H_TOKENER

#include "base.h"


using namespace std;

#define TOK_NONE        0
#define TOK_PAR_L       1
#define TOK_PAR_R       2
#define TOK_OP          3
#define TOK_VALUE       4


struct token {
  uchar type;
  value f;
  opid o;
  uchar i;
  static token empty();
  static token val(value f);
  static token op(opid op);
  static token parl(uchar t);
  static token parr(uchar t);
};


#if DEBUG>2
void printtoken(token& tok);
#endif

void tokenize(char* izraz, vector<token>& tokens);

#endif
